!-----------------------------------------------------------------------
! random number generators
! M. Staric, feb-2000, sept-2008, sept-211
!
!-----------------------------------------------------------------------

****  random number generators (based on RANLUX)

      REAL FUNCTION RND_NUM()

      IMPLICIT NONE
      REAL U

      CALL RANLUX(U,1)
      RND_NUM=U

      RETURN
      END


      REAL FUNCTION GAUS_RND(SIG)

      IMPLICIT NONE
      REAL SIG

      REAL U(2), PI
      DATA PI /0./
      SAVE PI

      IF(SIG.LE.0) THEN
         GAUS_RND=0.
         RETURN
      ENDIF

      IF(PI.EQ.0) PI=4.*ATAN(1.)
      CALL RANLUX(U,2)
      GAUS_RND=SIG*SQRT(-2.*LOG(U(1)))*COS(2.*PI*U(2))

      RETURN
      END


      INTEGER FUNCTION POISSON_RND(MEAN)

      IMPLICIT NONE
      REAL MEAN
      REAL A, U, P, GAUS_RND
      INTEGER K

      IF(MEAN.LE.0) THEN
         POISSON_RND=0
      ELSE IF(MEAN.GT.10) THEN
         POISSON_RND=MAX(NINT(MEAN+GAUS_RND(SQRT(MEAN))),0)
      ELSE
         A=1.
         K=0
         P=EXP(-MEAN)
         DO WHILE(.TRUE.)
            CALL RANLUX(U,1)
            A=A*U
            IF(A.LT.P) THEN
               POISSON_RND=K
               RETURN
            ENDIF
            K=K+1
         ENDDO
      ENDIF

      END



